git instaweb: enable remote_heads
[git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 git_broken_path_fix () {
15         case ":$PATH:" in
16         *:$1:*) : ok ;;
17         *)
18                 PATH=$(
19                         SANE_TOOL_PATH="$1"
20                         IFS=: path= sep=
21                         set x $PATH
22                         shift
23                         for elem
24                         do
25                                 case "$SANE_TOOL_PATH:$elem" in
26                                 (?*:/bin | ?*:/usr/bin)
27                                         path="$path$sep$SANE_TOOL_PATH"
28                                         sep=:
29                                         SANE_TOOL_PATH=
30                                 esac
31                                 path="$path$sep$elem"
32                                 sep=:
33                         done
34                         echo "$path"
35                 )
36                 ;;
37         esac
38 }
39
40 # @@BROKEN_PATH_FIX@@
41
42 die() {
43         echo >&2 "$@"
44         exit 1
45 }
46
47 GIT_QUIET=
48
49 say () {
50         if test -z "$GIT_QUIET"
51         then
52                 printf '%s\n' "$*"
53         fi
54 }
55
56 if test -n "$OPTIONS_SPEC"; then
57         usage() {
58                 "$0" -h
59                 exit 1
60         }
61
62         parseopt_extra=
63         [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64                 parseopt_extra="--keep-dashdash"
65
66         eval "$(
67                 echo "$OPTIONS_SPEC" |
68                         git rev-parse --parseopt $parseopt_extra -- "$@" ||
69                 echo exit $?
70         )"
71 else
72         dashless=$(basename "$0" | sed -e 's/-/ /')
73         usage() {
74                 die "Usage: $dashless $USAGE"
75         }
76
77         if [ -z "$LONG_USAGE" ]
78         then
79                 LONG_USAGE="Usage: $dashless $USAGE"
80         else
81                 LONG_USAGE="Usage: $dashless $USAGE
82
83 $LONG_USAGE"
84         fi
85
86         case "$1" in
87                 -h|--h|--he|--hel|--help)
88                 echo "$LONG_USAGE"
89                 exit
90         esac
91 fi
92
93 set_reflog_action() {
94         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95         then
96                 GIT_REFLOG_ACTION="$*"
97                 export GIT_REFLOG_ACTION
98         fi
99 }
100
101 git_editor() {
102         if test -z "${GIT_EDITOR:+set}"
103         then
104                 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
105         fi
106
107         eval "$GIT_EDITOR" '"$@"'
108 }
109
110 git_pager() {
111         if test -t 1
112         then
113                 GIT_PAGER=$(git var GIT_PAGER)
114         else
115                 GIT_PAGER=cat
116         fi
117         : ${LESS=-FRSX}
118         export LESS
119
120         eval "$GIT_PAGER" '"$@"'
121 }
122
123 sane_grep () {
124         GREP_OPTIONS= LC_ALL=C grep "$@"
125 }
126
127 sane_egrep () {
128         GREP_OPTIONS= LC_ALL=C egrep "$@"
129 }
130
131 is_bare_repository () {
132         git rev-parse --is-bare-repository
133 }
134
135 cd_to_toplevel () {
136         cdup=$(git rev-parse --show-toplevel) &&
137         cd "$cdup" || {
138                 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
139                 exit 1
140         }
141 }
142
143 require_work_tree () {
144         test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
145         die "fatal: $0 cannot be used without a working tree."
146 }
147
148 get_author_ident_from_commit () {
149         pick_author_script='
150         /^author /{
151                 s/'\''/'\''\\'\'\''/g
152                 h
153                 s/^author \([^<]*\) <[^>]*> .*$/\1/
154                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
155
156                 g
157                 s/^author [^<]* <\([^>]*\)> .*$/\1/
158                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
159
160                 g
161                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
162                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
163
164                 q
165         }
166         '
167         encoding=$(git config i18n.commitencoding || echo UTF-8)
168         git show -s --pretty=raw --encoding="$encoding" "$1" -- |
169         LANG=C LC_ALL=C sed -ne "$pick_author_script"
170 }
171
172 # Clear repo-local GIT_* environment variables. Useful when switching to
173 # another repository (e.g. when entering a submodule). See also the env
174 # list in git_connect()
175 clear_local_git_env() {
176         unset $(git rev-parse --local-env-vars)
177 }
178
179 # Make sure we are in a valid repository of a vintage we understand,
180 # if we require to be in a git repository.
181 if test -z "$NONGIT_OK"
182 then
183         GIT_DIR=$(git rev-parse --git-dir) || exit
184         if [ -z "$SUBDIRECTORY_OK" ]
185         then
186                 test -z "$(git rev-parse --show-cdup)" || {
187                         exit=$?
188                         echo >&2 "You need to run this command from the toplevel of the working tree."
189                         exit $exit
190                 }
191         fi
192         test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
193                 echo >&2 "Unable to determine absolute path of git directory"
194                 exit 1
195         }
196         : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
197 fi
198
199 # Fix some commands on Windows
200 case $(uname -s) in
201 *MINGW*)
202         # Windows has its own (incompatible) sort and find
203         sort () {
204                 /usr/bin/sort "$@"
205         }
206         find () {
207                 /usr/bin/find "$@"
208         }
209         is_absolute_path () {
210                 case "$1" in
211                 [/\\]* | [A-Za-z]:*)
212                         return 0 ;;
213                 esac
214                 return 1
215         }
216         ;;
217 *)
218         is_absolute_path () {
219                 case "$1" in
220                 /*)
221                         return 0 ;;
222                 esac
223                 return 1
224         }
225 esac